import * as React from 'react';
import isFunction from 'lodash/isFunction';
import get from 'lodash/get';
import isNullOrUndefined from './isNullOrUndefined';

function cloneCell(Cell, props) {
  return React.cloneElement(Cell, props);
}

function colSpanCells(cells) {
  var nextCells = [];

  for (var i = 0; i < cells.length; i += 1) {
    var _cells$i$props = cells[i].props,
        width = _cells$i$props.width,
        colSpan = _cells$i$props.colSpan;
    /**
     * 如果存在 colSpan 属性，就去找它的下一个 Cell,
     * 看看值是否是 isNullOrUndefined，，如果为空这可以合并这个单元格
     */

    if (colSpan) {
      var nextWidth = width;

      for (var j = 0; j < colSpan; j += 1) {
        var nextCell = cells[i + j];

        if (nextCell) {
          var _nextCell$props = nextCell.props,
              rowData = _nextCell$props.rowData,
              rowIndex = _nextCell$props.rowIndex,
              children = _nextCell$props.children,
              colSpanWidth = _nextCell$props.width,
              isHeaderCell = _nextCell$props.isHeaderCell,
              dataKey = _nextCell$props.dataKey;
          var cellText = isFunction(children) ? children(rowData, rowIndex) : get(rowData, dataKey);

          if (rowData && isNullOrUndefined(cellText) || isHeaderCell && isNullOrUndefined(children)) {
            nextWidth += colSpanWidth;
            cells[i + j] = cloneCell(nextCell, {
              removed: true
            });
          }
        }
      }

      nextCells.push(cloneCell(cells[i], {
        width: nextWidth
      }));
      continue;
    }

    nextCells.push(cells[i]);
  }

  return nextCells;
}

export default colSpanCells;